#ifndef DNSRESOLVER_H
#define DNSRESOLVER_H
#include <socket.h>
#include <netdb.h>
#include <MReaderSWriter.h>
#include <SReaderSWriter.h>
#include "InProgressList.h"
#include "HostNameList.h"
#include "HostInfoList.h"
#pragma export on
class DNSResolver
{
  public:
    DNSResolver(int32 fmax = 20);
    DNSResolver(DNSResolver&);
    
    virtual ~DNSResolver();
    DNSResolver& operator = (DNSResolver&);
    
    bool Init();
    bool InitOK()const;
    void Uninit();

    status_t Lookup(const char *hostname,struct sockaddr_in *addr,bool usecache = true);
    void CacheSize(int32);
    int32 CacheSize()const;
  private:
    status_t LookupUseCache(const char *hostname,struct sockaddr_in *addr);
  private:
    MReaderSWriter *fcachesem;
    SReaderSWriter *fprogresssem;
    SReaderSWriter *fadditionsem;
    InProgressList *finprogresslist;
    HostNameList   *fhostnamelist;
    HostInfoList   *fhostinfolist;
    int32          fmax;
    bool finit;
};
#pragma export off
#endif